## boost1.57 1.57.0+dfsg

=== debian/changelog ===
boost1.57 (1.57.0+dfsg-2~mx15+1) mx; urgency=medium

  * Rebuild for MX 15.
  * Don't force use of gcc-5.
 -- Steven Pusser <stevep@mxlinux.org>  Sat, 19 May 2018 14:38:08 -0700

boost1.57 (1.57.0+dfsg-2) experimental; urgency=medium

  * Build with C++11 ABI, and gcc-5.

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Tue, 30 Jun 2015 10:18:19 +0100

boost1.57 (1.57.0+dfsg-1) experimental; urgency=medium

  * New upstream release.

 -- Dimitri John Ledkov <dimitri.j.ledkov@linux.intel.com>  Thu, 12 Mar 2015 00:47:08 +0000

boost1.55 (1.55.0+dfsg-3) unstable; urgency=medium

  * patches/boost-1.55-128bit_int_support.patch: New. Patch fixing build
    where 128-bit integer not supported, cherry-picked from upstream.
    Closes: #758892.
  
  * patches/ppc64el-fp_traits-ibm-long-double.patch: New.  Patch removing
    fp_traits_non_native for long double on powerPC, which is apparently
    broken.  Closes: #761926.

  * control.in, control: Update vcs URLs.
  
 -- Steve M. Robbins <smr@debian.org>  Thu, 18 Sep 2014 22:45:15 -0500

boost1.55 (1.55.0+dfsg-2) unstable; urgency=medium

  * Disable pch on arm64, to avoid FTBFS. (Closes: #750956)
  * Speed up qemu-static builds a little, by not working perl many times
    when computing version strings to use.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 10 Jun 2014 10:16:51 +0100

boost1.55 (1.55.0+dfsg-1) unstable; urgency=medium

  * Convert debian/copyright to copyright-format 1.0.
  * Use Uscan extension https://wiki.debian.org/UscanEnhancements to
    declare excluded file (W3C validation icon)
  * Use uscan to download current version of boost, and thus
    auto-repackage with above non-dfsg file removed. Or
    e.g. --svn-download-orig option to svn-buildpackage.
  * Adjust version parsing in the debian/rules to keep the same versioning
    information.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Sun, 11 May 2014 01:22:15 +0100

boost1.55 (1.55.0-2) unstable; urgency=medium

  * In libboost-python1.55-dev drop gccxml to Suggests as it's not
    available on all architectures, is based upon old gcc, and not at all
    required to compile boost-python based projects.
  * Mark libboost1.55-dev & libboost-coroutine1.55-dev as Multi-Arch same.
  * Automate more of building boost without mpi, or just mpi portions.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 02 May 2014 15:54:44 +0100

boost1.55 (1.55.0-1) unstable; urgency=low

  [ Steve M. Robbins ]
  * New upstream.  
    - control.in, control: regenerated using update-control.py.  Set
      Standards-Version to 3.9.5.

  * Remove patches applied upstream:
    - 001-coroutine.patch
    - 002-date-time.patch
    - boost-1.44-py3.1.patch
    - boost-1.54.0-thread-link_atomic.patch
    - 85160.patch
    - eglibc-long-long.patch

  * patches/endian.patch: Remove.  Upstream changed endian detection.
  
  * patches/boost-1.55.0-001-log_fix_dump_avx2.patch: New.  Upstream patch
    to fix incorrect output of the dump manipulator, when used on
    AVX2-enabled CPU (e.g. Intel Haswell).
  
  * rules: Suppress warnings about unused local typedefs
    (-Wno-unused-local-typedefs) because they are massively generated by
    Boost Concept Check Library.

  [ Dimitri John Ledkov ]
  * Refresh patches/ELFv2-libboost1.54-dev-context-asm.patch
  * Refresh patches/boost-python-examples.patch: Hopefully does not
    reopen: #452410.
  * Enable context library on ppc64, ppc64el.

 -- Steve M. Robbins <smr@debian.org>  Sat, 04 Jan 2014 17:08:19 -0600

boost1.54 (1.54.0-5) UNRELEASED; urgency=low

  [ William Grant ]
  * debian/patches/eglibc-long-long.patch: Fix build with eglibc 2.18.
  * debian/rules: Treat ppc64el like ppc64.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Wed, 18 Dec 2013 12:15:55 +0000

boost1.54 (1.54.0-4) unstable; urgency=low

  [ Dmitrijs Ledkovs ]
  * Multi-arch most -dev packages (excluding python, mpi). Initial patches
    based on the work by Helmut Grohne. (Closes: #710413, #693247)
  * Split boost auxiliary tools into a separate Multi-Arch:foreign package.
  * Build-depend on dh-python to gain arch-qualified python extension names.
  * Create permament libboost_python.[a|so] symlinks (LP: #1217237) as
    python2.7 is the last python2 series release.
  * Correct the dependency on libstdc++, it's actually libstdc++-4.8-dev,
    not libstdc++6-4.8-dev.
  * Demote gccxml from Depends to Recommends in the libboost-python-dev
    package. (Closes: #726172)
  * Apply patch from Boost upstream to resolve BOOST_LCAST_HAS_INT128
    issue (#8790) (Closes: #727750)

  [ Steve M. Robbins ]
  * rules: Disable context for mips64 and mips64el.  Closes: #728616.
  * patches/hppa-long-double-config.patch: New.  Fixes definition of
    BOOST_MATH_NO_LONG_DOUBLE_MATH_FUNCTIONS for hppa (thanks, Dave
    Anglin).  Closes: #729479.
  * control.in(libboost1.54-dev): Add "Suggests" relationship to packages
    libmpfrc++-dev & libntl-dev because Boost.Multiprecision provides
    wrappers for them.  Closes: #731048.

  [ Matthias Klose ]
  * Add support for powerpc ELFv2.

 -- Steve M. Robbins <smr@debian.org>  Wed, 04 Dec 2013 00:50:47 -0600

boost1.54 (1.54.0-3) unstable; urgency=low

  [ Steve M. Robbins ]
  * control: Add depends on libboost1.54-dev omitted from recently added
    libraries (atomic, context, and coroutine).
  * patches/boost-1.54.0-thread-link_atomic.patch: New.  Link Boost.Thread
    to Boost.Atomic if necessary.  Closes: #721577, #721544.  Also have
    libboost-thread1.54-dev depend on libboost-atomic1.54-dev.
  * control: fix short description of libboost-exception1.54-dev; see
    #720160.

  [ Matthias Klose ]
  * Configure with --disable-long-double --wihtout-context on Aarch64

  [ Dmitrijs Ledkovs ]
  * Use anonscm URLs.
  * libboost-dev: Specify dependency on current libstdc++6-4.8-dev,
    instead of obsolete libstdc++6-4.4-dev. Fixes Multi-Arch
    installation (LP: #1209193)
  * Specify --with-icu=/usr to unconditionally trigger HAVE_ICU define,

